# Coding Interview University

> Първоначално създадох това като кратък списък с теми за учене, за това как се става софтуерен инженер, но то прерасна в този огромен списък, който виждате в момента. След като преминах през този учебен план, [бях нает като софтуерен инженер в Amazon](https://startupnextdoor.com/ive-been-acquired-by-amazon/?src=ciu)! Най-вероятно няма да Ви се налага да учите колкото на мен, но все пак всичко, от което се нуждаете е тук.
>
> Учих между 8-12 часа на ден в продължение на няколко месеца. Това е историята ми: [Why I studies full-time for 8 months for a Google interview](https://medium.freecodecamp.org/why-i-studied-full-time-for-8-months-for-a-google-interview-cc662ce9bb13)
>
> **Моля обърнете внимание:** Няма да Ви се налага да учите колкото мен. Загубих много време, учейки неща, които нямах нужда да знам. Може да прочетете повече за това надолу. Ще Ви помогна да достигнете до крайната цел без да прахосвате скъпото си време.
>
> Темите, изредени тук, ще Ви подготвят добре за техническо интервю за почти всяка една компания, включително гигантите Amazon, Facebook, Google и Microsoft
>
> _Пожелавам Ви успех!_

<details>
<summary>Преводи:</summary>

-   [中文版本](translations/README-cn.md)
-   [Tiếng Việt - Vietnamese](translations/README-vi.md)
-   [Español](translations/README-es.md)
-   [Português Brasileiro](translations/README-ptbr.md)
-   [Polish](translations/README-pl.md)
-   [繁體中文](translations/README-tw.md)
-   [Japanese (日本語)](translations/README-ja.md)
-   [Russian](translations/README-ru.md)
-   [German](translations/README-de.md)
-   [Bahasa Indonesia](translations/README-id.md)
-   [ខ្មែរ - Khmer](translations/README-kh.md)
-   [Uzbek](translations/README-uz.md)

</details>

<details>
<summary>Текущи преводи:</summary>

-   [हिन्दी](https://github.com/jwasham/coding-interview-university/issues/81)
-   [עברית](https://github.com/jwasham/coding-interview-university/issues/82)
-   [Arabic](https://github.com/jwasham/coding-interview-university/issues/98)
-   [Turkish](https://github.com/jwasham/coding-interview-university/issues/90)
-   [French](https://github.com/jwasham/coding-interview-university/issues/89)
-   [Українська](https://github.com/jwasham/coding-interview-university/issues/106)
-   [Korean(한국어)](https://github.com/jwasham/coding-interview-university/issues/118)
-   [Telugu](https://github.com/jwasham/coding-interview-university/issues/117)
-   [Urdu](https://github.com/jwasham/coding-interview-university/issues/519)
-   [Thai](https://github.com/jwasham/coding-interview-university/issues/156)
-   [Greek](https://github.com/jwasham/coding-interview-university/issues/166)
-   [Malayalam](https://github.com/jwasham/coding-interview-university/issues/239)
-   [Bulgarian](https://github.com/jwasham/coding-interview-university/issues/1032)

</details>

<div align="center">
	<hr />
    <p>
        <a href="https://github.com/sponsors/jwasham"><strong>Become a sponsor</strong> and support Coding Interview University!</a>
    </p>
    <p>
        <strong>Special thanks to:</strong>
    </p>
    <p>
        <a href="https://oss.capital/">
            <div>
                <img src="https://d3j2pkmjtin6ou.cloudfront.net/sponsors/oss-capital.svg" width="350" alt="OSS Capital">
            </div>
            <div>
                <sup><strong>Founded in 2018, OSS Capital is the first and only venture capital platform focused<br>exclusively on supporting early-stage COSS (commercial open source) startup founders.</strong></sup>
            </div>
        </a>
    </p>
    <br />
    <p>
        <a href="https://www.gitpod.io/?utm_campaign=jwasham&utm_medium=referral&utm_content=coding-interview-university&utm_source=github">
            <div>
                <img src="https://d3j2pkmjtin6ou.cloudfront.net/sponsors/gitpod-logo-light-theme.svg" width="300" alt="Gitpod">
            </div>
            <div>
                <p>
                    <strong>Dev environments built for the cloud</strong>
                </p>
            </div>
            <div>
                <sup>Natively integrated with GitLab, GitHub, and Bitbucket, Gitpod automatically and continuously prebuilds dev environments for all your branches. As a result team members can instantly start coding with fresh dev environments for each new task - no matter if you are building a new feature, want to fix a bug, or work on a code review.</sup>
            </div>
        </a>
    </p>
    <hr />
</div>

## Какво е това?

![Coding at the whiteboard - from HBO's Silicon Valley](https://d3j2pkmjtin6ou.cloudfront.net/coding-at-the-whiteboard-silicon-valley.png)

Това е моят многомесечен план за ставане на софтуерен инженер към голяма компания.

**Изисквания:**

-   Малко опит с програмиране (променливи, цикли, методи/функции и т.н)
-   Търпение
-   Време

Обърнете внимание, че това е учебен план за **софтуерно инженерство**, а не за уеб разработка. Големите компании като Google, Amazon, Facebook и Microsoft различават софтуерното инженерство и уеб разработката. Amazon, например, имат Frontend инженери (FEE) и Software Development инженери (SDE). Това са 2 отделни позиции и интервютата за тях няма да са еднакви, тъй като всяка една от тях има своите специфики. Тези компании изискват знания по компютърни науки за позиции свързани със софтуерно инженерство/разработка

---

## Съдържание

### Учебният план

-   [Какво е това?](#какво-е-това)
-   [Защо да го ползвате?](#защо-да-го-ползвате)
-   [Как да го ползвате?](#как-да-го-ползвате)
-   [Не мислете, че не сте достатъчно умни](#не-мислете-че-не-сте-достатъчно-умни)
-   [Бележка за видео ресурсите](#бележка-за-видео-ресурсите)
-   [Изберете език за програмиране](#изберете-език-за-програмиране)
-   [Книги за структури от данни и алгоритми](#книги-за-структури-от-данни-и-алгоритми)
-   [Книги за подготовка за интервю](#книги-за-подготовка-за-интервю)
-   [Не повтаряйте грешките ми](#не-повтаряйте-грешките-ми)
-   [Какво няма да намерите тук](#какво-няма-да-намерите-тук)
-   [Дневния план](#дневния-план)
-   [Подготовка за въпроси за програмиране](#подготовка-за-въпроси-за-програмиране)
-   [Задачи по програмиране](#задачи-по-програмиране)

### Теми за учене

-   [Алгоритмична сложност / Big-O / Асимптотичен анализ](#алгоритмична-сложност--big-o--асимптотичен-анализ)
-   [Структури от данни](#структури-от-данни)
    -   [Масиви (Arrays)](#масиви)
    -   [Свързани списъци(Linked Lists)](#свързани-списъци)
    -   [Стек (Stack)](#стек)
    -   [Опашка (Queue)](#опашка)
    -   [Хеш таблици (Hash table)](#хеш-таблици)
-   [Повече знания](#повече-знания)
    -   [Двоично търсене (Binary search)](#двоично-търсене)
    -   [Побитови операции (Bitwise operations)](#побитови-операции)
-   [Дървета](#дървета)
    -   [Дървета - бележки & основи](#дървета---бележки--основи)
    -   [Дървета за двоично търсене: BSTs (Binary search trees)](#дървета-за-двоично-търсене-bsts)
    -   [Heap / Priority Queue / Binary Heap](#heap--priority-queue--binary-heap)
    -   балансирани дървета за търсене (основна концепция, без детайли)
    -   обхождане: preorder, inorder, postorder, BFS, DFS
-   [Сортиране (Sorting)](#сортиране)
    -   selection
    -   insertion
    -   heapsort
    -   quicksort
    -   merge sort
-   [Графи (Graphs)](#графи)
    -   directed
    -   undirected
    -   adjacency matrix
    -   adjacency list
    -   traversals: BFS, DFS
-   [Още повече знания](#още-повече-знания)
    -   [Рекурсия (Recursion)](#рекурсия)
    -   [Динамично програмиране (Dynamic programming)](#динамично-програмиране)
    -   [Design Patterns](#design-patterns)
    -   [Комбинаторика & вероятности](#комбинаторика--вероятности)
    -   [NP, NP-Complete and Approximation Algorithms](#np-np-complete-and-approximation-algorithms)
    -   [Как компютрите обработват една програма](#как-компютрите-обработват-една-програма)
    -   [Кеширане (Caches)](#кеширане)
    -   [Процеси и нишки](#процеси-и-нишки)
    -   [Тестване (Testing)](#тестване)
    -   [String searching & manipulations](#string-searching--manipulations)
    -   [Tries](#tries)
    -   [Floating Point Numbers](#floating-point-numbers)
    -   [Уникод (Unicode)](#уникод)
    -   [Endianness](#endianness)
    -   [Мрежи (Networking)](#мрежи)
-   [Последен преглед](#последен-преглед)

### Как да спечелите позицията

-   [Актуализирайте резюмето си](#актуализирайте-резюмето-си)
-   [Намерете позиция](#намерете-позиция)
-   [Процесът на интервюто & обща подготовка](#процесът-на-интервюто--обща-подготовка)
-   [Мислете за това, когато дойде интервюто](#мислете-за-това-когато-дойде-интервюто)
-   [Подгответе въпроси за интервюиращия](#подгответе-въпроси-за-интервюиращия)
-   [След като са Ви наели](#след-като-са-ви-наели)

**---------------- Всичко оттук надолу е по желание ----------------**

### Допълнителни теми и ресурси

-   [Допълнителни книги](#допълнителни-книги)
-   [Системен дизайн, мащабируемост, обработка на данни](#системен-дизайн-мащабируемост-обработка-на-данни) (ако имате над 4 години опит)
-   [Additional Learning](#additional-learning)
    -   [Компилатори](#компилатори)
    -   [Emacs and vi(m)](#emacs-and-vim)
    -   [Unix command line tools](#unix-command-line-tools)
    -   [Information theory](#information-theory-videos)
    -   [Паритет & код на Хаминг](#паритет--код-на-хаминг)
    -   [Ентропия](#ентропия)
    -   [Криптография](#криптография)
    -   [Компресия](#компресия)
    -   [Компютърна сигурност](#компютърна-сигурност)
    -   [Garbage collection](#garbage-collection)
    -   [Паралелно програмиране](#паралелно-програмиране)
    -   [Системи за съобщения, сериализация и последователност](#системи-за-съобщения-сериализация-и-последователност)
    -   [A\*](#a)
    -   [Fast Fourier Transform](#fast-fourier-transform)
    -   [Bloom Filter](#bloom-filter)
    -   [HyperLogLog](#hyperloglog)
    -   [Locality-Sensitive Hashing](#locality-sensitive-hashing)
    -   [van Emde Boas Trees](#van-emde-boas-trees)
    -   [Разширени структури от данни](#разширени-структури-от-данни)
    -   [Балансирани дървета за търсене](#балансирани-дървета-за-търсене)
        -   AVL trees
        -   Splay trees
        -   Red/black trees
        -   2-3 search trees
        -   2-3-4 Trees (aka 2-4 trees)
        -   N-ary (K-ary, M-ary) trees
        -   B-Trees
    -   [k-D Trees](#k-d-trees)
    -   [Skip lists](#skip-lists)
    -   [Мрежови потоци](#мрежови-потоци)
    -   [Disjoint Sets & Union Find](#disjoint-sets--union-find)
    -   [Математика за бърза обработка](#математика-за-бърза-обработка)
    -   [Treap](#treap)
    -   [Линейно програмиране](#линейно-програмиране)
    -   [Geometry, Convex hull](#geometry-convex-hull-videos)
    -   [Дискретна математика](#дискретна-математика)
    -   [Machine Learning](#machine-learning)
-   [Допълнителни детайли по някои теми](#допълнителни-детайли-по-някои-теми)
-   [Видео серии](#видео-серии)
-   [Курсове по компютърни науки](#курсове-по-компютърни-науки)
-   [Papers](#papers)

---

## Защо да го ползвате?

Ако искате да работите като софтуерен инженер в голяма компания, това са нещата, които трябва да знаете.

Ако също като мен не сте учили компютърни науки в университет това ще Ви помогне да наваксате и ще Ви спести години.

Когато започнах този проект не знаех какво е стек или опашка, нямах представа какво е Big-O, не знаех нищо за дървета или как да обхождам графи. Ако трябваше да напиша сортиращ алгоритъм мога да Ви кажа, че бих се справил ужасно. Всяка от структурите от данни, които бях използвал досега бяха имплементирани в езика, който ползвах и нямах представа как работят реално. Никога не ми се беше налагало да управлявам памет освен ако някой от процесите, които бях пуснал не връщаха грешка "out of memory"- тогава се налагаше да търся заобиколен път. Бях ползвал хиляди асоциативни масиви и многоизмерни масиви няколко пъти, но никога преди не бях имплементирал структури от данни от нулата.

Планът е дълъг. Може да Ви отнеме месеци. Ако вече сте запознати с повечето от темите ще Ви отнеме много по-малко

## Как да го ползвате

Всичко надолу е само схематично изложение и трябва да преминете през темите от горе до долу.

## Не мислете, че не сте достатъчно умни

-   Успешните софтуерни инженери са умни, но много имат чувството, че не са достатъчно умни
-   [Митът за гениалния програмист](https://www.youtube.com/watch?v=0SARbwvhupQ)
-   [Опасно е да сте сами: битката с невидимите чудовища в IT](https://www.youtube.com/watch?v=1i8ylq4j_EY)

## Бележка за видео ресурсите

Някои видеа са достъпни само след записване в курс на Coursera или EdX- т.нар. MOOCs. Понякога се налага да изчакате няколко месеца, за да стартира ново издание на курса, така че няма да имате достъп до тях.

Би било чудесно такива ресурси да бъдат заменени с безплатни и свободнодостъпни публични източници като YouTube видеа (по възможност университетски лекции), за да могат всички да учат навсякъде и по всяко време, а не само когато даден курс върви в момента.

## Изберете език за програмиране

Трябва да изберете език за програмиране за интервютата на които ще се явявате, но също така трябва да изберете език, който можете да ползвате за учене на концепции от компютърните науки.

Желателно е този език да е един и същ, така ще Ви се налага да владеете само един език.

### За този учебен план

Когато преминавах през учебния план ползвах 2 езика за по-голямата част от нещата: C и Python

-   C: Език на много ниско ниво. Дава Ви възможност да се справяте с пойнтъри и управляване на паметта, за да разберете структурите от данни и алгоритмите на много дълбоко ниво. В езици за програмиране на по-високо ниво тези неща са скрити от Вас. В ежедневната работа това е прекрасно, но когато се учите как тези структури от данни работят е хубаво да усещате как става всичко.
    -   C е навсякъде. Ще виждате примери в книги, лекции, видеа _навсякъде_ докато учите.
    -   [The C Programming Language, Vol 2](https://www.amazon.com/Programming-Language-Brian-W-Kernighan/dp/0131103628)
        -   Това е кратка книга, но ще Ви даде добра представа за езика и с малко упражнения бързо ще имате добро владение над него. Ако разбирате C значи разбирате как програмите и паметта работят.
        -   Не трябва да се зачитате много надълбоко в книгата (или дори да я прочитате докрай). Нужно е само да сте уверени в способността си да четете и пишете в C.
        -   [Отговори на въпросите в книгата](https://github.com/lekkas/c-algorithms)
-   Python: модерен и много експресивен. Научих го защото е наистина много полезен и ми позволява да пиша по-малко код когато съм на интервю.

Това е моя личен избор. Вие можете да изберете каквото пожелаете, разбира се.

Може да не Ви трябват, но ето някои сайтове за учене на нов език:

-   [Exercism](https://exercism.org/tracks)
-   [Codewars](http://www.codewars.com)
-   [Codility](https://codility.com/programmers/)
-   [HackerEarth](https://www.hackerearth.com/)
-   [Sphere Online Judge (spoj)](http://www.spoj.com/)
-   [Codechef](https://www.codechef.com/)
-   [Codeforces](https://codeforces.com/)

### За интервюто Ви по програмиране

Може да изберете език, в който се чувствате комфортно за интервюто Ви, но за големите компании това са най-добрите опции:

-   C++
-   Java
-   Python

Може да ползвате и тези, но поразгледайте преди това, защото може да има уловки:

-   JavaScript
-   Ruby

Това е статия, която написах за избирането на език за вашето интервю:
[Pick One Language for the Coding Interview](https://startupnextdoor.com/important-pick-one-language-for-the-coding-interview/).
Това е оригиналната статия, на която базирах моя пост: http://blog.codingforinterviews.com/best-programming-language-jobs/

Трябва да се чувствате много удобно с вашия език и да сте знаещи.

Повече за вариантите:

-   [Изберете правилния език за вашето интервю по програмиране](http://www.byte-by-byte.com/choose-the-right-language-for-your-coding-interview/)

[Вижте ресурси за специфични езици тук](programming-language-resources.md)

## Книги за структури от данни и алгоритми

Тази книга ще положи вашата основа в компютърните науки.

Просто изберете една в език, с който ще се чувствате комфортно. Ще трябва да четете и да пишете код доста.

### C

-   [Algorithms in C, Parts 1-5 (Bundle), 3rd Edition](https://www.amazon.com/Algorithms-Parts-1-5-Bundle-Fundamentals/dp/0201756080)
    -   Основни познания, структури от данни, сортиране, търсене и алгоритми за графи

### Python

-   [Data Structures and Algorithms in Python](https://www.amazon.com/Structures-Algorithms-Python-Michael-Goodrich/dp/1118290275/)
    -   от Goodrich, Tamassia, Goldwasser
    -   Тази книга ми допадна много. Покрива всичко и още нещо
    -   'Питоничен' код
    -   Докладът ми за тази книга: https://startupnextdoor.com/book-report-data-structures-and-algorithms-in-python/

### Java

Изборът е ваш:

-   Goodrich, Tamassia, Goldwasser
    -   [Data Structures and Algorithms in Java](https://www.amazon.com/Data-Structures-Algorithms-Michael-Goodrich/dp/1118771338/)
-   Sedgewick and Wayne:
    -   [Algorithms](https://www.amazon.com/Algorithms-4th-Robert-Sedgewick/dp/032157351X/)
    -   Безплатен курс в Coursera, който покрива материала от книгата (воден от писателите!):
        -   [Algorithms I](https://www.coursera.org/learn/algorithms-part1)
        -   [Algorithms II](https://www.coursera.org/learn/algorithms-part2)

### C++

Изборът е ваш:

-   Goodrich, Tamassia, and Mount
    -   [Data Structures and Algorithms in C++, 2nd Edition](https://www.amazon.com/Data-Structures-Algorithms-Michael-Goodrich/dp/0470383275)
-   Sedgewick and Wayne
    -   [Algorithms in C++, Parts 1-4: Fundamentals, Data Structure, Sorting, Searching](https://www.amazon.com/Algorithms-Parts-1-4-Fundamentals-Structure/dp/0201350882/)
    -   [Algorithms in C++ Part 5: Graph Algorithms](https://www.amazon.com/Algorithms-Part-Graph-3rd-Pt-5/dp/0201361183/)

## Книги за подготовка за интервю

Няма нужда да купувате цял куп от тези книги. Честно казано "Cracking the Coding Interview" най-вероятно ще Ви бъде достатъчна, но аз си купих повече, за да се упражня по-добре. Но аз винаги правя прекалено много.

Купих тези двете, дадоха ми предостатъчно упражнение.

-   [Programming Interviews Exposed: Coding Your Way Through the Interview, 4th Edition](https://www.amazon.com/Programming-Interviews-Exposed-Through-Interview/dp/111941847X/)
    -   Отговори в C++ и Java
    -   Това е добра подготовка за "Cracking the Coding Interview"
    -   Не е прекалено сложна. Повечето проблеми са по-лесни от тези, които ще срещнете на интервю (от това, което аз съм прочел)
-   [Cracking the Coding Interview, 6th Edition](http://www.amazon.com/Cracking-Coding-Interview-6th-Programming/dp/0984782850/)
    -   отговори в Java

### Ако имате изобилие от време:

Изберете една:

-   [Elements of Programming Interviews (C++ version)](https://www.amazon.com/Elements-Programming-Interviews-Insiders-Guide/dp/1479274836)
-   [Elements of Programming Interviews in Python](https://www.amazon.com/Elements-Programming-Interviews-Python-Insiders/dp/1537713949/)
-   [Elements of Programming Interviews (Java version)](https://www.amazon.com/Elements-Programming-Interviews-Java-Insiders/dp/1517435803/) - [Companion Project - Method Stub and Test Cases for Every Problem in the Book](https://github.com/gardncl/elements-of-programming-interviews)

## Не повтаряйте грешките ми

Този списък се разрасна с времето и да, нещата излязоха извън контрол.

Споделям някои от грешките, които направих, за да имате по-добро преживяване и за да си спестите месеци с време.

### 1. Няма да запомните всичко

Изгледах часове с клипове и водих записки за всичко, но след месеци имаше доста неща, които не си спомнях. Прекарах 3 дена преразглеждайки бележките си, за да си припомня някои неща. Не се нуждаех от всичките тези знания.

Моля, прочетете това, за да не повторите грешките миЛ

[Да запазваме знания свързани с компютърни науки](https://startupnextdoor.com/retaining-computer-science-knowledge/).

### 2. Използвайте флаш карти

За да се справя с проблема си направих малък сайт за флаш карти, където можех да добавям 2 вида карти: общи и такива с код. Всяка карта има ралично форматиране. Направих сайта mobile-first, за да мога да ги разглеждам от телефона или таблета си, навсякъде където съм.

Направете свои безплатно:

-   [Flashcards site repo](https://github.com/jwasham/computer-science-flash-cards)

**НЕ ПРЕПОРЪЧВАМ да ползвате моите флаш карти.** Има прекалено много и някои от тях съдържат информация, която не е нужно да знаете.

Но ако не искате да ме послушате, ето:

-   [Базата ми от данни с флаш карти (1200 карти)](https://github.com/jwasham/computer-science-flash-cards/blob/main/cards-jwasham.db):
-   [Базата ми от данни с флаш карти (екстремно - 1800 карти)](https://github.com/jwasham/computer-science-flash-cards/blob/main/cards-jwasham-extreme.db):

Забележете, че аз прекалих и имам карти, които покриват всичко от assembly language и Python Trivia до machine learning и статистика. Прекалено много е за това, което се изисква.

**Бележка за флаш картите:** Първия път когато видите, че знаете отговора, не я отбелязвайте като "позната". Трябва да видите същата карта и отговора няколко пъти, преди наистина да знаете отговора. Повторението ще накара мозъка Ви наистина да запамети знанието.

### 3. Решавайте задачи от интервюта по програмиране докато учите

ТОВА Е МНОГО ВАЖНО.

Почнете да решавате задачи от интервюта по програмиране докато учите структури от данни и алгоритми.

Трябва да прилагате това, което учите като решавате задачи иначе ще забравите. Аз направих тази грешка.

Когато сте научили някоя тема и се чувствате що годе комфортно с нея, например **linked lists**:

1. Отворете една от [книгите за интервю за програмиране](#книги-за-подготовка-за-интервю) (или един от сайтовете със задачи, изредени по-долу)
1. Решете 2-3 задачи свързани с linked lists.
1. Продължете към следващата тема.
1. По-късно се върнете и отново решете 2-3 задачи свързани с linked lists.
1. Повтаряйте това с всяка нова тема, която учите.

**Продължавайте да решавате задачи докато учите всичко това, а не след това.**

Няма да ви наемат за знанията, които имате, а за това как ги прилагате.

Има много ресурси свързани с това надолу. Продължавайте да четете.

### 4. Фокусирайте се

Има много неща, които могат да отвлекат вниманието Ви и да Ви загубят ценно време. Да сте концентрирани е трудно. Пуснете си музика без текст и ще можете да се фокусирате сравнително добре.

## Какво няма да намерите тук

Това са широко разпространени технологии, но не и част от учебния план:

-   SQL
-   Javascript
-   HTML, CSS, и други front-end технологии

## Дневния план

Този курс преминава през множество от теми. Всяка от тях най-вероятно ще Ви отнеме няколко дена или дори седмица, или повече. Зависи от графика Ви.

Всеки ден взимайте следващата тема в списъка, изгледайте няколко клипа по тази тема и след това напишете имплементацията на въпросната структура от данни или алгоритъм в езика за програмиране, който сте избрали за този курс.

Можете да видите моя код тук:

-   [C](https://github.com/jwasham/practice-c)
-   [C++](https://github.com/jwasham/practice-cpp)
-   [Python](https://github.com/jwasham/practice-python)

Не е нужно да помните всеки алгоритъм наизуст. Необходимо е просто да ги разбирате достатъчно добре, за да можете да напишете собствена имплементация.

## Подготовка за въпроси за програмиране

    Защо това е тук? Аз не съм готов да се явя на интервю.

[Тогава се върни и прочети това.](#3-решавайте-задачи-от-интервюта-по-програмиране-докато-учите)

Защо трябва да се упражнявате да решавате задачи по програмиране:

-   Разпознаване на проблеми и знанието кога и къде да ползвате дадена структура от данни или алгоритъм
-   Събиране на изискванията за задачата
-   Изговаряне на мислите Ви докато решавате както ще правите на интервюто
-   Писане на код върху дъска или лист хартия вместо на компютър
-   Намиране на времевата и пространствената сложност на решенията Ви (вижте Big-O надолу)
-   Тестване на решенията Ви

Пишете код на дъска или лист хартия вместо на компютър. Тествайте с няколко различни входни данни. След това го напишете и тествайте на компютър.

Ако нямате дъска за писане вкъщи можете да си купите голям тефтер от магазин за арт материали. Можете просто да седите на дивана и да се упражнявате. Това е моята "дъска за дивана". Добавих химикала към снимката за съпоставка на размера. Ако използвате химикал бързо ще ви се поиска да можеше да триете написаното- бързо става мазало. **Аз ползвам молив и гума.**

![моята дъска за дивана](https://d3j2pkmjtin6ou.cloudfront.net/art_board_sm_2.jpg)

**Когато се упражнявате да решавате задачи по програмиране не трябва да помните решенията наизуст.**

## Задачи по програмиране

Не забравяйте основните книги за подготовка за интервюто по програмиране [тук](#книги-за-подготовка-за-интервю)

Решаване на задачи:

-   [Как да намерим решение](https://www.topcoder.com/community/competitive-programming/tutorials/how-to-find-a-solution/)
-   [Как да направим дисекция на условие на задача от Topcoder](https://www.topcoder.com/community/competitive-programming/tutorials/how-to-dissect-a-topcoder-problem-statement/)

Клипове за задачи от интервюта по програмиране:

-   [IDeserve (88 клипа)](https://www.youtube.com/playlist?list=PLamzFoFxwoNjPfxzaWqs7cZGsPYy0x_gI)
-   [Tushar Roy (5 плейлисти)](https://www.youtube.com/user/tusharroy2525/playlists?shelf_id=2&view=50&sort=dd)
    -   Супер за насоки за решаване на задачи
-   [Nick White - LeetCode Solutions (187 клипа)](https://www.youtube.com/playlist?list=PLU_sdQYzUj2keVENTP0a5rdykRSgg9Wp-)
    -   Добро обяснение на решението и кода
    -   Можете да изгледате няколко клипа в малък прозорец от време
-   [FisherCoder - LeetCode Solutions](https://youtube.com/FisherCoder)

Сайтове със задачи:

-   [LeetCode](https://leetcode.com/)
    -   Любимият ми сайт със задачи. Струва си парите за абонамент за времето, в което ще се подготвяте.
    -   Вижте клиповете на Nick White и FisherCoder Videos по-горе за насоки със някои задачи.
-   [HackerRank](https://www.hackerrank.com/)
-   [TopCoder](https://www.topcoder.com/)
-   [Geeks for Geeks](https://practice.geeksforgeeks.org/explore/?page=1)
-   [InterviewBit](https://www.interviewbit.com/)
-   [Project Euler](https://projecteuler.net/)

## Да започваме

Добре, стига сме говорили, нека да учим!

Но не забравяйте да решавате задачи от източниците по-горе докато учите!

## Алгоритмична сложност / Big-O / Асимптотичен анализ

-   Няма нищо за имплементация тук, единствено ще гледате клипове и ще си водите записки! Йей!
-   Има доста клипове тук. Просто изгледайте достатъчно докато не го разберете. Винаги можете да се върнете обратно и да преговорите.
-   Не се притеснявайте ако не разбирате всичката математика, която стои отзад.
-   Трябва просто да можете да изразите сложността на даден алгоритъм чрез Big-O
-   [ ] [Harvard CS50 - Asymptotic Notation (клип)](https://www.youtube.com/watch?v=iOq5kSKqeR4)
-   [ ] [Big O Notations (общ наръчник) (клип)](https://www.youtube.com/watch?v=V6mKVRU1evU)
-   [ ] [Big O Notation (и Omega, и Theta) - най-доброто математично обяснение (клип)](https://www.youtube.com/watch?v=ei-A_wy5Yxw&index=2&list=PL1BaGV1cIH4UhkL8a9bJGG356covJ76qN)
-   [ ] Skiena:
    -   [клип](https://www.youtube.com/watch?v=gSyDMtdPNpU&index=2&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b)
    -   [slides](https://archive.org/details/lecture2_202008)
-   [ ] [UC Berkeley Big O (клип)](https://archive.org/details/ucberkeley_webcast_VIS4YDpuP98)
-   [ ] [Амортизиран анализ (клип)](https://www.youtube.com/watch?v=B3SpQZaAZP4&index=10&list=PL1BaGV1cIH4UhkL8a9bJGG356covJ76qN)
-   [ ] TopCoder (includes recurrence relations and master theorem):
    -   [Computational Complexity: Section 1](https://www.topcoder.com/community/competitive-programming/tutorials/computational-complexity-section-1/)
    -   [Computational Complexity: Section 2](https://www.topcoder.com/community/competitive-programming/tutorials/computational-complexity-section-2/)
-   [ ] [Пищови](http://bigocheatsheet.com/)

Е, това е достатъчно за тази тема.

Когато четете "Cracking the Coding Interview" ще срещнете главата, която разглежда тази тема. Накрая на главата има кратък тест, който проверява дали можете да намерите сложността на различни алгоритми. Това е супер преговор и тест.

## Структури от данни

-   ### Масиви

    -   [ ] За масивите:
        -   [Arrays (клип)](https://www.coursera.org/lecture/data-structures/arrays-OsBSF)
        -   [UC Berkeley CS61B - Linear and Multi-Dim Arrays (клип)](https://archive.org/details/ucberkeley_webcast_Wp8oiO_CZZE) (Start watching from 15m 32s)
        -   [Dynamic Arrays (клип)](https://www.coursera.org/lecture/data-structures/dynamic-arrays-EwbnV)
        -   [Jagged Arrays (клип)](https://www.youtube.com/watch?v=1jtrQqYpt7g)
    -   [ ] Имплементирайте вектор (променлив масив с автоматично преоразмеряване):
        -   [ ] Упражнявайте се да пишете код, ползвайки масиви и пойнтъри. Ползвайте пойнтъри за преместване към индекс вместо индексиране
        -   [ ] New raw data array with allocated memory
            -   can allocate int array under the hood, just not use its features
            -   start with 16, or if starting number is greater, use power of 2 - 16, 32, 64, 128
        -   [ ] size() - номер на елементите
        -   [ ] capacity() - номер на елементите, които може да побира
        -   [ ] is_empty()
        -   [ ] at(index) - връща елемента на дадения индекс, ако индекса е извън границите на масива връща грешка
        -   [ ] push(item)
        -   [ ] insert(index, item) - вкарва елемента на дадения елемент, измествайки съществуващия елемент на този индекс и всички елементи след него надясно
        -   [ ] prepend(item) - може да добавя елементи на индекс 0
        -   [ ] pop() - премахва елемент от края и връща стойността му
        -   [ ] delete(index) - изтрива елемента на дадения индекс и измества всички елементи след него наляво
        -   [ ] remove(item) - търси стойността на елемента и премахва всички индекси, които я съдържат
        -   [ ] find(item) - търси стойността на елемента и връща първия индекс, който я съдържа, или -1 ако няма такъв елемент
        -   [ ] resize(new_capacity) // private function
            -   когато достигнете максималния обем, преоразмерете като дублирате обема
            -   когато pop-вате елемент, ако обема на масива е 1/4 от капацитета му, преоразмерете масива наполовина
    -   [ ] Време
        -   O(1) за добавяне/премахване към края, индексиране или актуализиране
        -   O(n) за добавяне/премахване другаде
    -   [ ] Пространство
        -   contiguous in memory, so proximity helps performance
        -   нужно място = (капацитета на масива, който е >= n) \* размера на елемента, но дори 2n, пак е O(n)

-   ### Свързани списъци

    -   [ ] Описание:
        -   [ ] [Единично свързани списъци (клип)](https://www.coursera.org/lecture/data-structures/singly-linked-lists-kHhgK)
        -   [ ] [CS 61B - Linked Lists 1 (клип)](https://archive.org/details/ucberkeley_webcast_htzJdKoEmO0)
        -   [ ] [CS 61B - Linked Lists 2 (клип)](https://archive.org/details/ucberkeley_webcast_-c4I3gFYe3w)
    -   [ ] [Код в C (клип)](https://www.youtube.com/watch?v=QN6FPiD0Gzo) - не цялото видео, само частите за Node structs и алокация на памет
    -   [ ] Свързани списъци срещу масиви:
        -   [Core Linked Lists Vs Arrays (клип)](https://www.coursera.org/lecture/data-structures-optimizing-performance/core-linked-lists-vs-arrays-rjBs9)
        -   [Свързани списъци срещу масиви в истинския свят (клип)](https://www.coursera.org/lecture/data-structures-optimizing-performance/in-the-real-world-lists-vs-arrays-QUaUd)
    -   [ ] [Защо да избягваме свързаните списъци (клип)](https://www.youtube.com/watch?v=YQs6IC-vgmo)
    -   [ ] Аха: трябват Ви pointer to pointer знания:
            (за да можете да подавате pointer към функция, която може да промени адреса, към който сочи pointer-a)
            Тази страница служи само да схванете ptr to ptr. Не препоръчвам този стил на обхождане на списъка. Четливостта и поддържаемостта страдат заради хитрости.
        -   [Pointers to Pointers](https://www.eskimo.com/~scs/cclass/int/sx8.html)
    -   [ ] Имплементация:
        -   [ ] size() - връща броя на елементите
        -   [ ] empty() - булева стойност, връща true ако списъка е празен
        -   [ ] value_at(index) - връща стойността на n-тия елемент (почвайки от 0 за първия елемент)
        -   [ ] push_front(value) - добавя стойност към началото на списъка
        -   [ ] pop_front() - премахва първия елемент и връща стойността му
        -   [ ] push_back(value) - добавя елемент към края
        -   [ ] pop_back() - премахва последния елемент и връща стойността му
        -   [ ] front() - взима стойността на първия елемент
        -   [ ] back() - взима стойността на последния елемент
        -   [ ] insert(index, value) - вкарва елемента на дадения индекс, така че новия елемент да сочи към стария елемент на този индекс
        -   [ ] erase(index) - изтрива node-а на дадения индекс
        -   [ ] value_n_from_end(n) - връща стойността на node-а, седящ на позиция n от края на списъка
        -   [ ] reverse() - обръща списъка
        -   [ ] remove_value(value) - премахва първия елемент от списъка, съдържащ тази стойност
    -   [ ] Двойно свързан списък
        -   [Описание (клип)](https://www.coursera.org/lecture/data-structures/doubly-linked-lists-jpGKD)
        -   Няма нужда от имплементация

-   ### Стек

    -   [ ] [Стекове (клип)](https://www.coursera.org/lecture/data-structures/stacks-UdKzQ)
    -   [ ] Няма нужда да се имплементира. Имплементацията с масив е тривиална.

-   ### Опашка

    -   [ ] [Опашка (клип)](https://www.coursera.org/lecture/data-structures/queues-EShpq)
    -   [ ] [Circular buffer/FIFO](https://en.wikipedia.org/wiki/Circular_buffer)
    -   [ ] Имплементирайте със свързан списък с tail pointer:
        -   enqueue(value) - добавя стойност на опашката
        -   dequeue() - връща стойността и премахва най-предния елемент на опашката (front)
        -   empty()
    -   [ ] Имплементрайте с масив с фиксирана големина:
        -   enqueue(value) - добавя елемента в края на наличното пространство
        -   dequeue() - връща стойността и премахва най-предния елемент на опашката
        -   empty()
        -   full()
    -   [ ] Разход:
        -   лоша имплементация, ползвайки свързан списък където правим enqueue в началото и dequeue в края би била O(n)
            защото ще се нуждаете от предпоследния елемент, което ще предизвиква цялостно обхождане при всяко dequeue
        -   enqueue: O(1) (amortized, свъзран списък и масив [probing])
        -   dequeue: O(1) (свъзран списък и масив)
        -   empty: O(1) (свъзран списък и масив)

-   ### Хеш таблици

    -   [ ] Клипове:

        -   [ ] [Hashing with Chaining (клип)](https://www.youtube.com/watch?v=0M_kIqhwbFo&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=8)
        -   [ ] [Table Doubling, Karp-Rabin (клип)](https://www.youtube.com/watch?v=BRO7mVIFt08&index=9&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
        -   [ ] [Open Addressing, Cryptographic Hashing (клип)](https://www.youtube.com/watch?v=rvdJDijO2Ro&index=10&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
        -   [ ] [PyCon 2010: The Mighty Dictionary (клип)](https://www.youtube.com/watch?v=C4Kc8xzcA68)
        -   [ ] [PyCon 2017: The Dictionary Even Mightier (клип)](https://www.youtube.com/watch?v=66P5FMkWoVU)
        -   [ ] [(Advanced) Randomization: Universal & Perfect Hashing (клип)](https://www.youtube.com/watch?v=z0lJ2k0sl1g&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=11)
        -   [ ] [(За напреднали) Perfect hashing (клип)](https://www.youtube.com/watch?v=N0COwN14gt0&list=PL2B4EEwhKD-NbwZ4ezj7gyc_3yNrojKM9&index=4)

    -   [ ] Онлайн курсовe:

        -   [ ] [Core Hash Tables (клип)](https://www.coursera.org/lecture/data-structures-optimizing-performance/core-hash-tables-m7UuP)
        -   [ ] [Data Structures (клип)](https://www.coursera.org/learn/data-structures/home/week/4)
        -   [ ] [Phone Book Problem (клип)](https://www.coursera.org/lecture/data-structures/phone-book-problem-NYZZP)
        -   [ ] Дистрибутирани хеш таблици:
            -   [Instant Uploads And Storage Optimization In Dropbox (клип)](https://www.coursera.org/lecture/data-structures/instant-uploads-and-storage-optimization-in-dropbox-DvaIb)
            -   [Distributed Hash Tables (клип)](https://www.coursera.org/lecture/data-structures/distributed-hash-tables-tvH8H)

    -   [ ] Имплементирайте с масив, ползвайки linear probing
        -   hash(k, m) - m е размера на хеш таблицата
        -   add(key, value) - ако ключа съществува актуализирайте стойността
        -   exists(key)
        -   get(key)
        -   remove(key)

## Повече знания

-   ### Двоично търсене
    -   [ ] [Binary Search (клип)](https://www.youtube.com/watch?v=D5SrAga1pno)
    -   [ ] [Binary Search (клип)](https://www.khanacademy.org/computing/computer-science/algorithms/binary-search/a/binary-search)
    -   [ ] [детайли](https://www.topcoder.com/community/competitive-programming/tutorials/binary-search/)
    -   [ ] Имплементирайте:
        -   двоично търсене (на сортиран масив от integers)
        -   двоично търсене чрез рекурсия
-   ### Побитови операции
    -   [ ] [Bits cheat sheet](https://github.com/jwasham/coding-interview-university/blob/main/extras/cheat%20sheets/bits-cheat-sheet.pdf) - трябва да знаете доста от степените на 2 от (2^1 до 2^16 и 2^32)
    -   [ ] Бъдете сигурни, че разбирате добре битовата манипулация: &, |, ^, ~, >>, <<
        -   [ ] [думи](<https://en.wikipedia.org/wiki/Word_(computer_architecture)>)
        -   [ ] Добро въведение:
                [Bit Manipulation (клип)](https://www.youtube.com/watch?v=7jkIUgLC29I)
        -   [ ] [C Programming Tutorial 2-10: Bitwise Operators (клип)](https://www.youtube.com/watch?v=d0AwjSpNXR0)
        -   [ ] [Bit Manipulation](https://en.wikipedia.org/wiki/Bit_manipulation)
        -   [ ] [Bitwise Operation](https://en.wikipedia.org/wiki/Bitwise_operation)
        -   [ ] [Bithacks](https://graphics.stanford.edu/~seander/bithacks.html)
        -   [ ] [The Bit Twiddler](https://bits.stephan-brumme.com/)
        -   [ ] [The Bit Twiddler Interactive](https://bits.stephan-brumme.com/interactive.html)
        -   [ ] [Bit Hacks (клип)](https://www.youtube.com/watch?v=ZusiKXcz_ac)
        -   [ ] [Practice Operations](https://pconrad.github.io/old_pconrad_cs16/topics/bitOps/)
    -   [ ] 2s and 1s complement
        -   [Binary: Plusses & Minuses (Why We Use Two's Complement) (клип)](https://www.youtube.com/watch?v=lKTsv6iVxV4)
        -   [1s Complement](https://en.wikipedia.org/wiki/Ones%27_complement)
        -   [2s Complement](https://en.wikipedia.org/wiki/Two%27s_complement)
    -   [ ] Преброяване на набор от битове
        -   [4 ways to count bits in a byte (клип)](https://youtu.be/Hzuzo9NJrlc)
        -   [Count Bits](https://graphics.stanford.edu/~seander/bithacks.html#CountBitsSetKernighan)
        -   [How To Count The Number Of Set Bits In a 32 Bit Integer](http://stackoverflow.com/questions/109023/how-to-count-the-number-of-set-bits-in-a-32-bit-integer)
    -   [ ] Размяна на стойности:
        -   [Swap](https://bits.stephan-brumme.com/swap.html)
    -   [ ] Абсолютна стойност:
        -   [Absolute Integer](https://bits.stephan-brumme.com/absInteger.html)

## Дървета

-   ### Дървета - бележки & основи

    -   [ ] [Серия: Дървета (клип)](https://www.coursera.org/lecture/data-structures/trees-95qda)
    -   основна структура на дървото
    -   обхождане
    -   алгоритми за манипулиране
    -   [ ] [BFS(обхождане в ширина) and DFS(обхождане в дълбочина) (клип)](https://www.youtube.com/watch?v=uWL6FJhq5fM)
        -   бележки за BFS:
            -   level order (BFS, using queue)
            -   времева сложност O(n)
            -   пространствена сложност: в най-добрия случай: O(1), в най-лошия случай: O(n/2)=O(n)
        -   бележки за DFS:
            -   времева сложност: O(n)
            -   пространствена сложност:
                в най-добрия случай: O(log n) - средна височина на дървото
                в най-добрия случай: O(n)
            -   inorder (DFS: ляво, self, дясно)
            -   postorder (DFS: ляво, дясно, self)
            -   preorder (DFS: self, ляво, дясно)

-   ### Дървета за двоично търсене: BSTs

    -   [ ] [Преговор над двоични дървета за търсене (клип)](https://www.youtube.com/watch?v=x6At0nzX92o&index=1&list=PLA5Lqm4uh9Bbq-E0ZnqTIa8LRaL77ica6)
    -   [ ] [Въведение (клип)](https://www.coursera.org/learn/data-structures/lecture/E7cXP/introduction)
    -   [ ] [MIT (клип)](https://www.youtube.com/watch?v=9Jry5-82I68)
    -   C/C++:
        -   [ ] [Двоично дърво за търсене - имплементация в C/C++ (клип)](https://www.youtube.com/watch?v=COZK7NATh4k&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=28)
        -   [ ] [BST имплементация - memory allocation in stack and heap (клип)](https://www.youtube.com/watch?v=hWokyBoo0aI&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=29)
        -   [ ] [Намиране на мин. и макс. елемент в двоично дърво за търсенея (клип)](https://www.youtube.com/watch?v=Ut90klNN264&index=30&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        -   [ ] [Намиране на височината на двоично дърво (клип)](https://www.youtube.com/watch?v=_pnqMz5nrRs&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=31)
        -   [ ] [Обхождане на двоично дърво - стратегии за обхождане по ширина и по дълбочина (клип)](https://www.youtube.com/watch?v=9RHO6jU--GU&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=32)
        -   [ ] [Двоично дърво: преминаване на порядъка на ниво (клип)](https://www.youtube.com/watch?v=86g8jAQug04&index=33&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        -   [ ] [Обхождане на двоично дърво: Preorder, Inorder, Postorder (клип)](https://www.youtube.com/watch?v=gm8DUJJhmY4&index=34&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        -   [ ] [Проверка дали двоично дърво е двоично дърво за търсене (клип)](https://www.youtube.com/watch?v=yEwSGhSsT0U&index=35&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
        -   [ ] [Изтриване на възел от двоично дърво за търсене (клип)](https://www.youtube.com/watch?v=gcULXE7ViZw&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P&index=36)
        -   [ ] [Редовен наследник в двоично дърво (клип)](https://www.youtube.com/watch?v=5cPbNCrdotA&index=37&list=PL2_aWCzGMAwI3W_JlcBbtYTwiQSsOTa6P)
    -   [ ] Имплементирайте:
        -   [ ] insert // вкарване на стойност в дървото
        -   [ ] get_node_count // вземане на бройката на запазените стойности
        -   [ ] print_values // принтира стойностите в дървото от най-малкия до най-големия
        -   [ ] delete_tree
        -   [ ] is_in_tree // връща true ако дадената стойност съществува в дървото
        -   [ ] get_height // returns the height in nodes (single node's height is 1)
        -   [ ] get_min // връща най-малката стойност, съхранявана в дървото
        -   [ ] get_max // връща най-голямата стойност, съхранявана в дървото
        -   [ ] is_binary_search_tree
        -   [ ] delete_value
        -   [ ] get_successor // връща следващата най-голяма стойност след дадената, -1 ако такава не съществува

-   ### Heap / Priority Queue / Binary Heap
    -   визуализира се като дърво, но обикновенно е линейна структура (масив, свързан списък)
    -   [ ] [Heap](<https://en.wikipedia.org/wiki/Heap_(data_structure)>)
    -   [ ] [Въведение (клип)](https://www.coursera.org/learn/data-structures/lecture/2OpTs/introduction)
    -   [ ] [Наивни имплементации (клип)](https://www.coursera.org/learn/data-structures/lecture/z3l9N/naive-implementations)
    -   [ ] [Двоични дървета (клип)](https://www.coursera.org/learn/data-structures/lecture/GRV2q/binary-trees)
    -   [ ] [Tree Height Remark (клип)](https://www.coursera.org/learn/data-structures/supplement/S5xxz/tree-height-remark)
    -   [ ] [Основни операции (клип)](https://www.coursera.org/learn/data-structures/lecture/0g1dl/basic-operations)
    -   [ ] [Завършени двоични дървета (клип)](https://www.coursera.org/learn/data-structures/lecture/gl5Ni/complete-binary-trees)
    -   [ ] [Псевдокод (клип)](https://www.coursera.org/learn/data-structures/lecture/HxQo9/pseudocode)
    -   [ ] [Heap Sort - jumps to start (клип)](https://youtu.be/odNJmw5TOEE?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=3291)
    -   [ ] [Heap Sort (клип)](https://www.coursera.org/learn/data-structures/lecture/hSzMO/heap-sort)
    -   [ ] [Създаване на heap (клип)](https://www.coursera.org/learn/data-structures/lecture/dwrOS/building-a-heap)
    -   [ ] [MIT: Heaps and Heap Sort (клип)](https://www.youtube.com/watch?v=B7hVxCmfPtM&index=4&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    -   [ ] [CS 61B Lecture 24: Priority Queues (клип)](https://archive.org/details/ucberkeley_webcast_yIUFT6AKBGE)
    -   [ ] [Linear Time BuildHeap (max-heap)](https://www.youtube.com/watch?v=MiyLo8adrWw)
    -   [ ] Имплементирайте max-heap:
        -   [ ] insert
        -   [ ] sift_up - нужно е за insert
        -   [ ] get_max - връща най-голямата стойност без да я премахва
        -   [ ] get_size() - връща броя на елементите
        -   [ ] is_empty() - връща true ако heap-a не съдържа елементи
        -   [ ] extract_max - връща най-големия елемент и го премахва
        -   [ ] sift_down - нужно е за extract_max
        -   [ ] remove(x) - премахва елемента на индекс x
        -   [ ] heapify - създава heap от масив от елементи, нужно е за heap_sort
        -   [ ] heap_sort() - превръща несортиран масив в сортиран такъв, ползвайки max heap или min heap

## Сортиране

-   [ ] Бележки:

    -   Имплементирайте алгоритми за сортиране и знайте сложността в средния/ най-добрия/ най-лошия случай:
        -   без bubble sort - ужасен алгоритъм е - O(n^2), освен когато n <= 16
    -   [ ] Стабилност при сортиращите алгоритми ("Стабилен ли е Quicksort?")
        -   [Стабилност на сортиращите алгоритми](https://en.wikipedia.org/wiki/Sorting_algorithm#Stability)
        -   [Стабилност на сортиращите алгоритми](http://stackoverflow.com/questions/1517793/stability-in-sorting-algorithms)
        -   [Стабилност на сортиращите алгоритми](http://www.geeksforgeeks.org/stability-in-sorting-algorithms/)
        -   [Стабилност на сортиращите алгоритми](http://homepages.math.uic.edu/~leon/cs-mcs401-s08/handouts/stability.pdf)
    -   [ ] Кои алгоритми могат да се ползват чрез свързани списъци? Кои чрез масиви? Кои чрез двете?
        -   Не бих препоръчал да сортирате свързан списък, но би станало с merge sort.
        -   [Merge Sort за свързани списъци](http://www.geeksforgeeks.org/merge-sort-for-linked-list/)

-   За heapsort, вижте Heap структурата от данни по-горе. Heapsort е чудесен, но не е стабилен

-   [ ] [Sedgewick - Mergesort (5 клипа)](https://www.coursera.org/learn/algorithms-part1/home/week/3)

    -   [ ] [1. Mergesort](https://www.coursera.org/learn/algorithms-part1/lecture/ARWDq/mergesort)
    -   [ ] [2. Bottom up Mergesort](https://www.coursera.org/learn/algorithms-part1/lecture/PWNEl/bottom-up-mergesort)
    -   [ ] [3. Сортираща сложност](https://www.coursera.org/learn/algorithms-part1/lecture/xAltF/sorting-complexity)
    -   [ ] [4. Компаратори](https://www.coursera.org/learn/algorithms-part1/lecture/9FYhS/comparators)
    -   [ ] [5. Стабилност](https://www.coursera.org/learn/algorithms-part1/lecture/pvvLZ/stability)

-   [ ] [Sedgewick - Quicksort (4 клипа)](https://www.coursera.org/learn/algorithms-part1/home/week/3)

    -   [ ] [1. Quicksort](https://www.coursera.org/learn/algorithms-part1/lecture/vjvnC/quicksort)
    -   [ ] [2. Селекция](https://www.coursera.org/learn/algorithms-part1/lecture/UQxFT/selection)
    -   [ ] [3. Дублиращи се ключове](https://www.coursera.org/learn/algorithms-part1/lecture/XvjPd/duplicate-keys)
    -   [ ] [4. System Sorts](https://www.coursera.org/learn/algorithms-part1/lecture/QBNZ7/system-sorts)

-   [ ] UC Berkeley:

    -   [ ] [CS 61B Lecture 29: Sorting I (клип)](https://archive.org/details/ucberkeley_webcast_EiUvYS2DT6I)
    -   [ ] [CS 61B Lecture 30: Sorting II (клип)](https://archive.org/details/ucberkeley_webcast_2hTY3t80Qsk)
    -   [ ] [CS 61B Lecture 32: Sorting III (клип)](https://archive.org/details/ucberkeley_webcast_Y6LOLpxg6Dc)
    -   [ ] [CS 61B Lecture 33: Sorting V (клип)](https://archive.org/details/ucberkeley_webcast_qNMQ4ly43p4)

-   [ ] [Bubble Sort (клип)](https://www.youtube.com/watch?v=P00xJgWzz2c&index=1&list=PL89B61F78B552C1AB)
-   [ ] [Анализ на Bubble Sort (клип)](https://www.youtube.com/watch?v=ni_zk257Nqo&index=7&list=PL89B61F78B552C1AB)
-   [ ] [Insertion Sort, Merge Sort (клип)](https://www.youtube.com/watch?v=Kg4bqzAqRBM&index=3&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
-   [ ] [Insertion Sort (клип)](https://www.youtube.com/watch?v=c4BRHC7kTaQ&index=2&list=PL89B61F78B552C1AB)
-   [ ] [Merge Sort (клип)](https://www.youtube.com/watch?v=GCae1WNvnZM&index=3&list=PL89B61F78B552C1AB)
-   [ ] [Quicksort (клип)](https://www.youtube.com/watch?v=y_G9BkAm6B8&index=4&list=PL89B61F78B552C1AB)
-   [ ] [Selection Sort (клип)](https://www.youtube.com/watch?v=6nDMgr0-Yyo&index=8&list=PL89B61F78B552C1AB)

-   [ ] Код за Merge sort:
    -   [ ] [Using output array (C)](http://www.cs.yale.edu/homes/aspnes/classes/223/examples/sorting/mergesort.c)
    -   [ ] [Using output array (Python)](https://github.com/jwasham/practice-python/blob/master/merge_sort/merge_sort.py)
    -   [ ] [In-place (C++)](https://github.com/jwasham/practice-cpp/blob/master/merge_sort/merge_sort.cc)
-   [ ] Код за Quick sort:

    -   [ ] [Имплементация (C)](http://www.cs.yale.edu/homes/aspnes/classes/223/examples/randomization/quick.c)
    -   [ ] [Имплементация (C)](https://github.com/jwasham/practice-c/blob/master/quick_sort/quick_sort.c)
    -   [ ] [Имплементация (Python)](https://github.com/jwasham/practice-python/blob/master/quick_sort/quick_sort.py)

-   [ ] Имплементирайте:

    -   [ ] Mergesort: O(n log n) сложност в средния/ най-лошия случай
    -   [ ] Quicksort O(n log n) сложност в средния случай
    -   Selection sort и insertion sort са със сложност O(n^2) в средния/ най-лошия случай
    -   За heapsort, вижте Heap структурата от данни нагоре

-   [ ] Не е задължително, но препоръчвам:
    -   [ ] [Sedgewick - Radix Sorts (6 клипа)](https://www.coursera.org/learn/algorithms-part2/home/week/3)
        -   [ ] [1. Низове в Java](https://www.coursera.org/learn/algorithms-part2/lecture/vGHvb/strings-in-java)
        -   [ ] [2. Key Indexed Counting](https://www.coursera.org/learn/algorithms-part2/lecture/2pi1Z/key-indexed-counting)
        -   [ ] [3. Least Significant Digit First String Radix Sort](https://www.coursera.org/learn/algorithms-part2/lecture/c1U7L/lsd-radix-sort)
        -   [ ] [4. Most Significant Digit First String Radix Sort](https://www.coursera.org/learn/algorithms-part2/lecture/gFxwG/msd-radix-sort)
        -   [ ] [5. 3 Way Radix Quicksort](https://www.coursera.org/learn/algorithms-part2/lecture/crkd5/3-way-radix-quicksort)
        -   [ ] [6. Suffix Arrays](https://www.coursera.org/learn/algorithms-part2/lecture/TH18W/suffix-arrays)
    -   [ ] [Radix Sort](http://www.cs.yale.edu/homes/aspnes/classes/223/notes.html#radixSort)
    -   [ ] [Radix Sort (video)](https://www.youtube.com/watch?v=xhr26ia4k38)
    -   [ ] [Radix Sort, Counting Sort (linear time given constraints) (video)](https://www.youtube.com/watch?v=Nz1KZXbghj8&index=7&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    -   [ ] [Randomization: Matrix Multiply, Quicksort, Freivalds' algorithm (video)](https://www.youtube.com/watch?v=cNB2lADK3_s&index=8&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    -   [ ] [Сортиране в линейно време (клип)](https://www.youtube.com/watch?v=pOKy3RZbSws&list=PLUl4u3cNGP61hsJNdULdudlRL493b-XZf&index=14)

Като обобщение, това е визуализация на [15 алгоритъма за сортиране](https://www.youtube.com/watch?v=kPRA0W1kECg).
Ако ви трябват повече детайли на тази тема вижте секцията "Сортиране" в[Допълнителни детайли по някои теми](#допълнителни-детайли-по-някои-теми)

## Графи

Графите могат да се ползват за онагледяване на много проблеми в компютърните науки, така че тази секция е дълга, също както тази за дърветата и сортирането..

-   Бележки:

    -   Има 4 основни начина една графа да бъде представена в паметта:
        -   обекти и пойнтъри
        -   матрици на съседство
        -   списъци на съседство
        -   мап на съседство
    -   Запознайте се с всяка от начините за представяне и плюсовете, и минусите, които предоставят
    -   BFS и DFS - знайте изчислителната им сложност, компромисите, които носят и как да ги имплементирате в истински код
    -   Когато Ви зададат въпрос, първо потърсете решение с граф и преминете нататък ако няма такова

-   [ ] MIT(клипове):

    -   [ ] [Обхождане по ширина](https://www.youtube.com/watch?v=s-CYnVz-uh4&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=13)
    -   [ ] [Обхождане по дълбочина](https://www.youtube.com/watch?v=AfSk24UTFS8&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=14)

-   [ ] Skiena Lectures - чудесно въведение:

    -   [ ] [CSE373 2012 - Лекция 11 - Граф като структура от данни (клип)](https://www.youtube.com/watch?v=OiXxhDrFruw&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&index=11)
    -   [ ] [CSE373 2012 - Лекция 12 - Обхождане по ширина (клип)](https://www.youtube.com/watch?v=g5vF8jscteo&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&index=12)
    -   [ ] [CSE373 2012 - Лекция 13 - Алгоритми за графи (клип)](https://www.youtube.com/watch?v=S23W6eTcqdY&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&index=13)
    -   [ ] [CSE373 2012 - Лекция 14 - Алгоритми за графи (продължение) (клип)](https://www.youtube.com/watch?v=WitPBKGV0HY&index=14&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b)
    -   [ ] [CSE373 2012 - Лекция 15 - Алгоритми за графи (продължение 2) (клип)](https://www.youtube.com/watch?v=ia1L30l7OIg&index=15&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b)
    -   [ ] [CSE373 2012 - Лекция 16 - Алгоритми за графи (продължение 3) (клип)](https://www.youtube.com/watch?v=jgDOQq6iWy8&index=16&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b)

-   [ ] Графи (преговор и повече):

    -   [ ] [6.006 Задача за най-кратък път от един източник (клип)](https://www.youtube.com/watch?v=Aa2sqUhIn-E&index=15&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    -   [ ] [6.006 Дейкстра (клип)](https://www.youtube.com/watch?v=2E7MmKv0Y24&index=16&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb)
    -   [ ] [6.006 Белман-Форд (клип)](https://www.youtube.com/watch?v=ozsuci5pIso&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=17)
    -   [ ] [6.006 Как да забързаме Дейкстра (клип)](https://www.youtube.com/watch?v=CHvQ3q_gJ7E&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=18)
    -   [ ] [Aduni: Алгоритми за графи I - Топологично сортиране, Минимално обхващащи дървета, Алгоритъм на Прим - Лекция 6 (клип)](https://www.youtube.com/watch?v=i_AQT_XfvD8&index=6&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
    -   [ ] [Aduni: Алгоритми за графи II - DFS, BFS, Алгоритъм на Крускал, Union Find структура от данни - Лекция 7 (клип)](https://www.youtube.com/watch?v=ufj5_bppBsA&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=7)
    -   [ ] [Aduni: Алгоритми за графи III: Най-кратък път - Лекция 8 (клип)](https://www.youtube.com/watch?v=DiedsPsMKXc&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=8)
    -   [ ] [Aduni: Алгоритми за графи IV: Въведение в геометричните алгоритми - Лекция 9 (клип)](https://www.youtube.com/watch?v=XIAQRlNkJAw&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=9)
    -   [ ] ~~[CS 61B 2014 (от 58:09) (клип)](https://youtu.be/dgjX4HdMI-Q?list=PL-XXv-cvA_iAlnI-BQr9hjqADPBtujFJd&t=3489)~~
    -   [ ] [CS 61B 2014: Претеглени графи (клип)](https://archive.org/details/ucberkeley_webcast_zFbq8vOZ_0k)
    -   [ ] [Алчни алгоритми: Минимално обхващащо дърво (клип)](https://www.youtube.com/watch?v=tKwnms5iRBU&index=16&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    -   [ ] [Алгоритъм за граф на Kosaraju за силно свързани компоненти (клип)](https://www.youtube.com/watch?v=RpgcYiky7uw)

-   Пълен курс в Coursera:

    -   [ ] [Алгоритми за графи (клип)](https://www.coursera.org/learn/algorithms-on-graphs/home/welcome)

-   Аз ще имплементирам:
    -   [ ] DFS със списък на съседство (рекурсивно)
    -   [ ] DFS със списък на съседство (итеративно със стек)
    -   [ ] DFS с матрица на съседство (рекурсивно)
    -   [ ] DFS с матрица на съседство (итеративно със стек)
    -   [ ] BFS със списък на съседство
    -   [ ] BFS с матрица на съседство
    -   [ ] най-кратък път от един източник (Дейкстра)
    -   [ ] минимално обхващащо дърво
    -   Алгоритми основани върху DFS (вижте клиповете на Aduni по-горе):
        -   [ ] проверка за цикъл (нужно за топологичното сортиране, защото ще проверяваме за цикъла преди стартиране)
        -   [ ] топологично сортиране
        -   [ ] преброяване на свързаните компоненти в графа
        -   [ ] изреждане на силно свързаните компоненти
        -   [ ] проверка за двустранна графа

## Още повече знания

-   ### Рекурсия

    -   [ ] Лекции от Stanford за рекурсия и backtracking:
        -   [ ] [Лекция 8 | Абстракции за програмиране (клип)](https://www.youtube.com/watch?v=gl3emqCuueQ&list=PLFE6E58F856038C69&index=8)
        -   [ ] [Лекция 9 | Абстракции за програмиране (клип)](https://www.youtube.com/watch?v=uFJhEPrbycQ&list=PLFE6E58F856038C69&index=9)
        -   [ ] [Лекция 10 | Абстракции за програмиране (клип)](https://www.youtube.com/watch?v=NdF1QDTRkck&index=10&list=PLFE6E58F856038C69)
        -   [ ] [Лекция 11 | Абстракции за програмиране (клип)](https://www.youtube.com/watch?v=p-gpaIGRCQI&list=PLFE6E58F856038C69&index=11)
    -   Кога е подходящо да се използва?
    -   Как опашковата рекурсия е по-добра отколкото без?
        -   [ ] [Какво е опашкова рекурсия и защо е толкова лоша?](https://www.quora.com/What-is-tail-recursion-Why-is-it-so-bad)
        -   [ ] [Опашкова рекурсия (клип)](https://www.coursera.org/lecture/programming-languages/tail-recursion-YZic1)

-   ### Динамично програмиране

    -   Най-вероятно няма да срещнете задачи с динамично програмиране в интервютата си, но си струва да можете да разпознавате задачи, които са годни за решаване с динамично програмиране.
    -   Тази тема може да е доста сложна защото всяка задача, която може да се решава с ДП трябва да бъде дефинирана чрез рекурсивна връзка, а понякога може да е сложно да се измисли такава.
    -   Препоръчвам да разгледате много примери за задачи с ДП докато имате стабилно разбиране на структурата им.
    -   [ ] Клипове:
        -   клиповете от Skiena могат да бъдат сложни за проследяване, тъй като той понякога ползва дъската, която е прекалено малка, за да се види
        -   [ ] [Skiena: CSE373 2012 - Лекция 19 - Въведение в динамичното програмиране (клип)](https://youtu.be/Qc2ieXRgR0k?list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&t=1718)
        -   [ ] [Skiena: CSE373 2012 - Лекция 20 - Edit Distance (клип)](https://youtu.be/IsmMhMdyeGY?list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&t=2749)
        -   [ ] [Skiena: CSE373 2012 - Лекция 21 - Примери за динамично програмиране (клип)](https://youtu.be/o0V9eYF4UI8?list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&t=406)
        -   [ ] [Skiena: CSE373 2012 - Лекция 22 - Приложение на динамичното програмиране (клип)](https://www.youtube.com/watch?v=dRbMC1Ltl3A&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&index=22)
        -   [ ] [Simonson: Динамично програмиране 0 (starts at 59:18) (клип)](https://youtu.be/J5aJEcOr6Eo?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=3558)
        -   [ ] [Simonson: Динамично програмиране I - Лекция 11 (клип)](https://www.youtube.com/watch?v=0EzHjQ_SOeU&index=11&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
        -   [ ] [Simonson: Динамично програмиране II - Лекия 12 (клип)](https://www.youtube.com/watch?v=v1qiRwuJU7g&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=12)
        -   [ ] Списък с единични задачи за динамично програмиране (кратки са):
                [Динамично програмиране (клип)](https://www.youtube.com/playlist?list=PLrmLmBdmIlpsHaNTPP_jHHDx_os9ItYXr)
    -   [ ] Бележки от лекции в Yale:
        -   [ ] [Динамично програмиране](http://www.cs.yale.edu/homes/aspnes/classes/223/notes.html#dynamicProgramming)
    -   [ ] Coursera:
        -   [ ] [The RNA secondary structure problem (клип)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/80RrW/the-rna-secondary-structure-problem)
        -   [ ] [Алгоритъм за динамично програмиране (клип)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/PSonq/a-dynamic-programming-algorithm)
        -   [ ] [Илюстриране на алгоритъма за ДП (клип)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/oUEK2/illustrating-the-dp-algorithm)
        -   [ ] [Време за изпълнение на алгоритъма за ДП (клип)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/nfK2r/running-time-of-the-dp-algorithm)
        -   [ ] [ДП срещу рекурсивна имплементация (клип)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/M999a/dp-vs-recursive-implementation)
        -   [ ] [Глобално подравняване на последователности по двойки (клип)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/UZ7o6/global-pairwise-sequence-alignment)
        -   [ ] [Локално подравняване на последователности по двойки (клип)](https://www.coursera.org/learn/algorithmic-thinking-2/lecture/WnNau/local-pairwise-sequence-alignment)

-   ### Design patterns

    -   [ ] [Бърз преговор върху UML (клип)](https://www.youtube.com/watch?v=3cmzqZzwNDM&list=PLGLfVvz_LVvQ5G-LdJ8RLqe-ndo7QITYc&index=3)
    -   [ ] Научете тези схеми:
        -   [ ] strategy
        -   [ ] singleton
        -   [ ] adapter
        -   [ ] prototype
        -   [ ] decorator
        -   [ ] visitor
        -   [ ] factory, abstract factory
        -   [ ] facade
        -   [ ] observer
        -   [ ] proxy
        -   [ ] delegate
        -   [ ] command
        -   [ ] state
        -   [ ] memento
        -   [ ] iterator
        -   [ ] composite
        -   [ ] flyweight
    -   [ ] [Глава Част 1) - Patterns (клип)](https://youtu.be/LAP2A80Ajrg?list=PLJ9pm_Rc9HesnkwKlal_buSIHA-jTZMpO&t=3344)
    -   [ ] [Глава 6 (Част 2) - Abstraction-Occurrence, General Hierarchy, Player-Role, Singleton, Observer, Delegation (клип)](https://www.youtube.com/watch?v=U8-PGsjvZc4&index=12&list=PLJ9pm_Rc9HesnkwKlal_buSIHA-jTZMpO)
    -   [ ] [Глава 6 (Част 3) - Adapter, Facade, Immutable, Read-Only Interface, Proxy (клип)](https://www.youtube.com/watch?v=7sduBHuex4c&index=13&list=PLJ9pm_Rc9HesnkwKlal_buSIHA-jTZMpO)
    -   [ ] [Поредица от клипове (27 клипа)](https://www.youtube.com/playlist?list=PLF206E906175C7E07)
    -   [ ] [Head First Design Patterns](https://www.amazon.com/Head-First-Design-Patterns-Freeman/dp/0596007124)
        -   Знам, че каноничната книга е "Design Patterns: Elements of Reusable Object-Oriented Software", но Head First е чудесна за начинаещи в ОО.
    -   [ ] [Удобен справочник: 101 Design Patterns & Tips for Developers](https://sourcemaking.com/design-patterns-and-tips)
    -   [ ] [Design patterns за хора](https://github.com/kamranahmedse/design-patterns-for-humans#structural-design-patterns)

-   ### Комбинаторика & вероятности

    -   [ ] [Математични умения: как да намираме пермутации, вариации и комбинации (клип)](https://www.youtube.com/watch?v=8RRo6Ti9d0U)
    -   [ ] [Make School: Вероятности (клип)](https://www.youtube.com/watch?v=sZkAAk9Wwa4)
    -   [ ] [Make School: Още вероятности и Марковски вериги (клип)](https://www.youtube.com/watch?v=dNaJg-mLobQ)
    -   [ ] Khan Academy:
        -   Оформление на курса:
            -   [ ] [Основна теоритична вероятност](https://www.khanacademy.org/math/probability/probability-and-combinatorics-topic)
        -   Само клиповете - 41 (всичките са прости и къси):
            -   [ ] [Вероятностите- обяснени (клип)](https://www.youtube.com/watch?v=uzkc-qNVoOk&list=PLC58778F28211FA19)

-   ### NP, NP-Complete and Approximation Algorithms

    -   Знайте за най-известните задачи за NP-завършеност като пътуващия търговец и бъдете сигурни, че можете да ги разпознавате, когато интервюиращия ви ги даде прикрити
    -   Знайте какво означава NP-завършен.
    -   [ ] [Изчислителна сложност (клип)](https://www.youtube.com/watch?v=moPtwq_cVH8&list=PLUl4u3cNGP61Oq3tWYp6V_F-5jb5L2iHb&index=23)
    -   [ ] Simonson:
        -   [ ] [Алчни алгоритми II & Въведение в NP-завършеността (клип)](https://youtu.be/qcGnJ47Smlo?list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&t=2939)
        -   [ ] [NP-завършеност II & Редукции (клип)](https://www.youtube.com/watch?v=e0tGC6ZQdQE&index=16&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
        -   [ ] [NP-завършеност III (клип)](https://www.youtube.com/watch?v=fCX1BGT3wjE&index=17&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm)
        -   [ ] [NP-завършеност IV (клип)](https://www.youtube.com/watch?v=NKLDp3Rch3M&list=PLFDnELG9dpVxQCxuD-9BSy2E7BWY3t5Sm&index=18)
    -   [ ] Skiena:
        -   [ ] [CSE373 2012 - Лекция 23 - Въведение в NP-завършеността (клип)](https://youtu.be/KiK5TVgXbFg?list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b&t=1508)
        -   [ ] [CSE373 2012 - Лекция 24 - Доказване на NP-завършеност (клип)](https://www.youtube.com/watch?v=27Al52X3hd4&index=24&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b)
        -   [ ] [CSE373 2012 - Лекция 25 - Предизвикателство NP-завършеност (клип)](https://www.youtube.com/watch?v=xCPH4gwIIXM&index=25&list=PLOtl7M3yp-DV69F32zdK7YJcNXpTunF2b)
    -   [ ] [Сложност: P, NP, NP-завършеност, редукции (клип)](https://www.youtube.com/watch?v=eHZifpgyH_4&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=22)
    -   [ ] [Сложност: Алгоритми за приближаване (клип)](https://www.youtube.com/watch?v=MEz1J9wY2iM&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp&index=24)
    -   [ ] [Сложност: Алгоритми с фиксирани параметри (клип)](https://www.youtube.com/watch?v=4q-jmGrmxKs&index=25&list=PLUl4u3cNGP6317WaSNfmCvGym2ucw3oGp)
    -   Peter Norvig обсъжда почти оптимални решения на задачата за пътуващия търговец:
        -   [Jupyter Notebook](http://nbviewer.jupyter.org/url/norvig.com/ipython/TSP.ipynb)
    -   Страници 1048 - 1140 в CLRS ако я имате.

-   ### Как компютрите обработват една програма

    -   [ ] [Как CPU-то изпълнява програми (клип)](https://www.youtube.com/watch?v=XM4lGflQFvA)
    -   [ ] [Как компютрите пресмятат - ALU (клип)](https://youtu.be/1I5ZMmrOfnA)
    -   [ ] [Регистри и RAM (клип)](https://youtu.be/fpnE6UAfbtU)
    -   [ ] [Централният процесор (CPU) (клип)](https://youtu.be/FZGugFqdr60)
    -   [ ] [Инструкции и програми (клип)](https://youtu.be/zltgXvg6r3k)
